#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_RoomRewardCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_RoomRewardCFG> M_RoomRewardCFG::msSingleton(nullptr);

int M_RoomRewardCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_RoomRewardCFGData* M_RoomRewardCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_RoomRewardCFGData>& M_RoomRewardCFG::GetMapData()
{
	return mMapData;
}

void M_RoomRewardCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_RoomRewardCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_RoomRewardCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mNeedItem = element->IntAttribute("NeedItem");
		data.mNeedCount = element->IntAttribute("NeedCount");
		{
			const char* RewardItems = element->Attribute("RewardItems");
			std::vector<std::string> vecRewardItems;
			boost::split(vecRewardItems, RewardItems, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItems.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItems[i].c_str(), &temp))
				{
					data.mRewardItems.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		{
			const char* GiftRewardItems = element->Attribute("GiftRewardItems");
			std::vector<std::string> vecGiftRewardItems;
			boost::split(vecGiftRewardItems, GiftRewardItems, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGiftRewardItems.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGiftRewardItems[i].c_str(), &temp))
				{
					data.mGiftRewardItems.push_back(temp);
				}
			}
		}
		{
			const char* GiftRewardCount = element->Attribute("GiftRewardCount");
			std::vector<std::string> vecGiftRewardCount;
			boost::split(vecGiftRewardCount, GiftRewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGiftRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGiftRewardCount[i].c_str(), &temp))
				{
					data.mGiftRewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_RoomRewardCFG::Load()
{
	Load("../Config/M_RoomRewardCFG.xml");
}

M_RoomRewardCFG* M_RoomRewardCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_RoomRewardCFG());
	}
	return msSingleton.get();
}
